% TP de TdS

%Reprsentation temporelle
%********************

clear
x=-5:0.01:5
y=exp(-abs(x))
plot (x,y)
title('Reprsentation temporelle')
xlabel('x')
ylabel('f(x) = exp (- abs (x) )')

%On trace la fonction x ( t ) = exp( - | t | ) sur l'intervalle [ -5 , 5 ]

%Reprsentation frquentielle
%*********************

clear
f=-3:0.01:3
y=2./(1+4*pi.^2*f.^2)
plot (f,y)
title('Reprsentation Frquentielle')
xlabel('f')
ylabel('X (f) = -2 / (1 + 4 * PI.^2 * f.^2)')

%On obtient ici la reprsentation thorique (aprs calcul) de la transforme de Fourier du signal x ( t ).

%Calcul d'une transforme de Fourier
%***************************

%Approximer la transforme de Fourier
%--------------------------------------

clear
t=-5:0.01:5
x=exp(-abs(t))
Fx=fftshift(0.01*fft(x))
f=-50:0.0999:49.9001
plot(f,abs(Fx))
axis([-3 3 0 2])

%On obtient ici la reprsentation pratique (de Matlab) de la transforme de Fourier toujours du mme signal x ( t ), %grce  la fonction " fftshift(Te*fft( x ( t ) ) ". On dnote une petite diffrence entre les courbes pratique et %thorique: la courbe pratique est lgrement dcale vers la droite. Ceci prouve l'imprcision de la mthode utilise %par Matlab pour le calcul de la transforme de Fourier.
 


%Transforme de Fourier inverse
%-------------------------------

clear
f=-50:0.0999:49.9001
fx=2./(1+4*pi.^2*f.^2)
xt=abs(ifft(fx)/0.01)
t=-5:0.01:5
plot(t,xt)

%Il n'tait pas demand de traiter cette question. De toute faon, le rsultat est faux : La courbe ne correspond pas %du tout  celle de x ( t ).

%Proprit de dcalage frquentielle
%----------------------------------

clear
t=-5:0.01:5
x=exp(-abs(t)).*exp(i*2*pi*5*t)
Fx=fftshift(0.01*fft(x))
f=-50:0.0999:49.9001

%Jusqu' maintenant toutes les courbes taient centres en zro, suite  un dcalage frquentielle de f = 5 Hz, les %courbes sont dsormais centres en 5 Hz.

%Module

Mod=abs(Fx)
plot(f,Mod)
axis([2 8 0 3])

%Partie reel

R=real(Fx)
plot(f,R)
axis([2 8 -3 3])

%Partie imaginaire

I=imag(Fx)
plot(f,I)
axis([2 8 -0.3 0.4])